<?php
/*
Plugin Name: Local Business SEO
Description: Local business SEO plugin will optimize your website with microdata for google, bing and yahoo. Specifying the type of business your website if for can produce a 100% ranking increase for local keywords. Works great with other seo plugins including Yoast SEO.
Version: 0.2.2
Plugin URI: http://microdataproject.org
Plugin URI: mailto:contact@microdataproject.org
Author: Christopher Dubeau
Author URI: mailto:me@christopherdubeau.com
Author URI: http://christopherdubeau.com
Contributor: Sid Creations
Contributor URI: mailto:contact@sidcreations.com
Contributor URI: http://sidcreations.com


Copyright 2013  Microdata Project / Christopher Dubeau  (email : me@christopherdubeau.com, email: contact@microdataproject.org)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


// DEFINE PLUGIN ID
define( 'MDP_LOCAL_BUSINESS_SEO_ID' , 'mdp_local_business_info' );
// DEFINE PLUGIN NICK
define( 'MDP_LOCAL_BUSINESS_SEO_NICK' , 'Local SEO' );


if ( ! class_exists ( 'mdpInfo' ) ) {

	class mdpInfo
	{

		public $mdp_name;

		private function __construct ()
		{

			$this->name = 'mdpLocalBusinessInfo';

			register_activation_hook ( __FILE__ , array ( $this , 'mdp_activate' ) );
			register_deactivation_hook ( __FILE__ , array ( $this , 'mdp_deactivate' ) );
			register_uninstall_hook ( __FILE__ , array ( $this , 'mdp_uninstall' ) );

		}

		/** function/activate
		 * Usage: create tables if not exist and activates the plugin
		 * Arg(0): null
		 * Return: void
		 */

		private function mdp_activate ()
		{

			add_option ( 'mdp_status' );
			add_option ( 'mdp_type' );
			add_option ( 'mdp_name' );
			add_option ( 'mdp_description' );
			add_option ( 'mdp_url' );
			add_option ( 'mdp_image' );
			add_option ( 'mdp_sameas' );
			add_option ( 'mdp_payment_accepted' );
			add_option ( 'mdp_street_address' );
			add_option ( 'mdp_address_locality' );
			add_option ( 'mdp_address_region' );
			add_option ( 'mdp_postal_code' );
			add_option ( 'mdp_address_country' );
			add_option ( 'mdp_email' );
			add_option ( 'mdp_telephone' );
			add_option ( 'mdp_fax_number' );
			add_option ( 'mdp_best_rating' );
			add_option ( 'mdp_rating_value' );
			add_option ( 'mdp_open' );
			add_option ( 'mdp_close' );
			add_option ( 'mdp_dow' );
			add_option ( 'mdp_seeks' );
			add_option ( 'mdp_seeks_url' );
			add_option ( 'mdp_seeks_name' );
			add_option ( 'mdp_seeks_description' );
			add_option ( 'mdp_member' );
			add_option ( 'mdp_member_url' );
			add_option ( 'mdp_member_name' );
			add_option ( 'mdp_member_description' );
			add_option ( 'mdp_longitude' );
			add_option ( 'mdp_latitude' );
		}

		/** function/deactivate
		 * Usage: create tables if not exist and activates the plugin
		 * Arg(0): null
		 * Return: void
		 */

		private function mdp_deactivate ()
		{

			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_status' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_type' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_name' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_description' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_url' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_image' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_sameas' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_payment_accepted' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_street_address' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_address_locality' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_address_region' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_postal_code' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_address_country' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_email' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_telephone' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_fax_number' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_best_rating' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_worst_rating' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_rating_count' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_rating_value' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_open' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_close' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_dow' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks_url' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks_name' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks_description' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member_url' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member_name' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member_description' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_longitude' );
			unregister_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_latitude' );

		}

		/** function/uninstall
		 * Usage: create tables if not exist and activates the plugin
		 * Arg(0): null
		 * Return: void
		 */

		private function mdp_uninstall ()
		{

			delete_option ( 'mdp_status' );
			delete_option ( 'mdp_type' );
			delete_option ( 'mdp_name' );
			delete_option ( 'mdp_description' );
			delete_option ( 'mdp_url' );
			delete_option ( 'mdp_image' );
			delete_option ( 'mdp_sameas' );
			delete_option ( 'mdp_payment_accepted' );
			delete_option ( 'mdp_street_address' );
			delete_option ( 'mdp_address_locality' );
			delete_option ( 'mdp_address_region' );
			delete_option ( 'mdp_postal_code' );
			delete_option ( 'mdp_address_country' );
			delete_option ( 'mdp_email' );
			delete_option ( 'mdp_telephone' );
			delete_option ( 'mdp_fax_number' );
			delete_option ( 'mdp_best_rating' );
			delete_option ( 'mdp_rating_value' );
			delete_option ( 'mdp_open' );
			delete_option ( 'mdp_close' );
			delete_option ( 'mdp_dow' );
			delete_option ( 'mdp_seeks' );
			delete_option ( 'mdp_seeks_url' );
			delete_option ( 'mdp_seeks_name' );
			delete_option ( 'mdp_seeks_description' );
			delete_option ( 'mdp_member' );
			delete_option ( 'mdp_member_name' );
			delete_option ( 'mdp_member_url' );
			delete_option ( 'mdp_member_description' );
			delete_option ( 'mdp_longitude' );
			delete_option ( 'mdp_latitude' );
		}

		/** function/file_path
		 * Usage: includes the plugin file path
		 * Arg(0): null
		 * Return: void
		 */

		public static function mdp_file_path (
			$file
		) {

			return ABSPATH . 'wp-content/plugins/' . str_replace ( basename ( __FILE__ ) , "" , plugin_basename ( __FILE__ ) ) . $file;
		}


		/** function/register_settings
		 * Usage: registers the plugins options
		 * Arg(0): null
		 * Return: void
		 */
		public static function mdp_register ()
		{

			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_status' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_type' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_name' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_description' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_url' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_image' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_sameas' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_payment_accepted' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_street_address' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_address_locality' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_address_region' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_postal_code' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_address_country' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_email' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_telephone' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_fax_number' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_best_rating' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_worst_rating' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_rating_count' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_rating_value' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_open' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_close' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_dow' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks_name' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks_url' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_seeks_description' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member_name' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member_url' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_member_description' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_longitude' );
			register_setting ( MDP_LOCAL_BUSINESS_SEO_ID . '_options' , 'mdp_latitude' );

		}

		/** function/method
		 * Usage: hooking (registering) the plugin menu
		 * Arg(0): null
		 * Return: void
		 */
		public static function mdp_menu ()
		{

			$icon_url = str_replace ( basename ( __FILE__ ) , "" , plugin_basename ( __FILE__ ) );
			add_menu_page ( MDP_LOCAL_BUSINESS_SEO_NICK . ' Plugin Options' , MDP_LOCAL_BUSINESS_SEO_NICK , 'read' , MDP_LOCAL_BUSINESS_SEO_ID . '_options' , array ( 'mdpInfo' , 'mdp_options_page' ) , plugins_url ( $icon_url . 'mdp_icon32.png' ) );
		}

		/** function/options_page
		 * Usage: show options/settings for plugin
		 * Arg(0): null
		 * Return: void
		 */
		public static function mdp_options_page ()
		{

			$plugin_id = MDP_LOCAL_BUSINESS_SEO_ID;
			// display options page
			include ( self::mdp_file_path ( 'options.php' ) );

		}
	}
}

add_action ( 'admin_init' , array ( 'mdpInfo' , 'mdp_register' ) );
add_action ( 'admin_menu' , array ( 'mdpInfo' , 'mdp_menu' ) );
add_action ( 'user_admin_menu' , array ( 'mdpInfo' , 'mdp_menu' ) );

if ( get_option ( 'mdp_status' ) == 1 ) {

	include ( 'mdp_info.php' );
	add_filter ( 'wp_footer' , 'LocalBusiness' );

}
$localBusiness = new mdpInfo();

?>